/*
 * CharReader.java Created on 28. kvten 2004, 23:28
 */

package net.sf.tomp.pp;

/**
 * @author tomp
 */
public class CharReader {

    private String src; // = "%html{%head{}%body{ %tag1 attr1='attr1value'
                        // attr2=\"\"{} %tag2 attr3=\"attr3value\"{Obsah tag2}
                        // %tag4%enclosedtag4 attr4=\"attr4value\"{}}}";

    private int index;

    private int len;

    private boolean eof = false;

    public CharReader(String s) {
        src = s;
        len = s.length();
    }

    public char next() {
        if (index < len) {
            eof = false;
            return src.charAt(index++);
        } else {
            eof = true;
            return 0;
        }
    }

    public char at() {
        return at(index);
    }

    public char at(int i) {
        if (i < len) {
            return src.charAt(i);
        } else {
            return 0;
        }
    }

    public boolean eof() {
        return eof;
    }

    public char nextNonspace(char c) {
        while (!eof() && Character.isWhitespace(c)) {
            c = next();
        }
        return c;
    }

    public int index() {
        return index;
    }

    public char pushback() {
        index--;
        return at();
    }

    public String substring(int textBegin, int textEnd) {
        return src.substring(textBegin, textEnd);
    }
}